/**********************************************************************/
/*                                                                    */
/*  ARSDDEEX.H                                                        */
/*                                                                    */
/*  DESCRIPTION:  Header file containing external declarations for    */
/*                the OnDemand DDE interface.                         */
/*                                                                    */
/* COPYRIGHT:                                                         */
/*  5622-662 (C) COPYRIGHT IBM CORPORATION 1996,1997                  */
/*  All Rights Reserved                                               */
/*  Licensed Materials - Property of IBM                              */
/*                                                                    */
/*  US Government Users Restricted Rights - Use, duplication or       */
/*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*                                                                    */
/* NOTE: This program sample is provided on an as-is basis.           */
/*       The licensee of the OnDemand product is free to copy, revise,*/
/*       modify, and make derivative works of this program sample     */
/*       as they see fit.                                             */
/*                                                                    */
/**********************************************************************/
#ifndef _H_DDEEX_
#define _H_DDEEX_

#include <windows.h>

/**********************************************************************/
/* DDE Service and Topic Names                                        */
/**********************************************************************/
#define ARS_DDE_SERVICE                       TEXT("ARS")
#define ARS_DDE_TOPIC                         TEXT("ARS")

/**********************************************************************/
/* DDE Commands                                                       */
/**********************************************************************/
#define ARS_DDE_CMD_ACTIVATE_DOC              TEXT("ACTIVATE_DOC")
#define ARS_DDE_CMD_ACTIVATE_FOLDER           TEXT("ACTIVATE_FOLDER")
#define ARS_DDE_CMD_ANNOTATE_DOC              TEXT("ANNOTATE_DOC")
#define ARS_DDE_CMD_ARRANGE_DOC_WINDOWS       TEXT("ARRANGE_DOCS")
#define ARS_DDE_CMD_CLEAR_ALL_FIELDS          TEXT("CLEAR_FIELDS")
#define ARS_DDE_CMD_CLOSE_ALL_DOCS            TEXT("CLOSE_ALL_DOCS")
#define ARS_DDE_CMD_CLOSE_ALL_FOLDERS         TEXT("CLOSE_ALL_FOLDERS")
#define ARS_DDE_CMD_CLOSE_DOC                 TEXT("CLOSE_DOC")
#define ARS_DDE_CMD_CLOSE_FOLDER              TEXT("CLOSE_FOLDER")
#define ARS_DDE_CMD_COPY_DOC_PAGES            TEXT("COPY_DOC_PAGES")
#define ARS_DDE_CMD_DELETE_DOC                TEXT("DELETE_DOC")
#define ARS_DDE_CMD_UPDATE_DOC                TEXT("UPDATE_DOC")
#define ARS_DDE_CMD_DESELECT_DOC              TEXT("DESELECT_DOC")
#define ARS_DDE_CMD_DISABLE_SWITCH_FOCUS      TEXT("DISABLE_SWITCH")
#define ARS_DDE_CMD_ENABLE_SWITCH_FOCUS       TEXT("ENABLE_SWITCH")
#define ARS_DDE_CMD_EXIT                      TEXT("EXIT")
#define ARS_DDE_CMD_GET_DISPLAY_FIELDS        TEXT("GET_DISPLAY_FIELDS")
#define ARS_DDE_CMD_GET_DOC_VALUES            TEXT("GET_DOC_VALUES")
#define ARS_DDE_CMD_GET_FOLDER_FIELDS         TEXT("GET_FOLDER_FIELDS")
#define ARS_DDE_CMD_GET_FOLDERS               TEXT("GET_FOLDERS")
#define ARS_DDE_CMD_GET_NUM_DOC_PAGES         TEXT("GET_NUM_DOC_PAGES")
#define ARS_DDE_CMD_GET_NUM_DOCS_IN_LIST      TEXT("GET_NUM_DOCS_IN_LIST")
#define ARS_DDE_CMD_GET_PRINTERS              TEXT("GET_PRINTERS")
#define ARS_DDE_CMD_GET_QUERY_FIELDS          TEXT("GET_QUERY_FIELDS")
#define ARS_DDE_CMD_GET_SERVERS               TEXT("GET_SERVERS")
#define ARS_DDE_CMD_LOGOFF                    TEXT("LOGOFF")
#define ARS_DDE_CMD_LOGON                     TEXT("LOGON")
#define ARS_DDE_CMD_OPEN_DOC                  TEXT("OPEN_DOC")
#define ARS_DDE_CMD_OPEN_FOLDER               TEXT("OPEN_FOLDER")
#define ARS_DDE_CMD_PRINT_DOC                 TEXT("PRINT_DOC")
#define ARS_DDE_CMD_RESTORE_DEFAULTS          TEXT("RESTORE_DEFAULTS")
#define ARS_DDE_CMD_RETRIEVE_DOC              TEXT("RETRIEVE_DOC")
#define ARS_DDE_CMD_SEARCH_FOLDER             TEXT("SEARCH_FOLDER")
#define ARS_DDE_CMD_SELECT_DOC                TEXT("SELECT_DOC")
#define ARS_DDE_CMD_SET_FIELD_DATA            TEXT("SET_FIELD_DATA")
#define ARS_DDE_CMD_SET_FOCUS                 TEXT("SET_FOCUS")
#define ARS_DDE_CMD_SET_HELP_PATH             TEXT("SET_HELP_PATH")
#define ARS_DDE_CMD_SET_USER_MSG_MODE         TEXT("SET_USER_MSG_MODE")
#define ARS_DDE_CMD_SHOW_WINDOW               TEXT("SHOW_WINDOW")
#define ARS_DDE_CMD_STORE_DOC                 TEXT("STORE_DOC")
#define ARS_DDE_CMD_CHANGE_PASSWORD           TEXT("CHANGE_PASSWORD")

/**********************************************************************/
/* DDE Command Parameters                                             */
/**********************************************************************/
#define ARS_DDE_WINDOW                        TEXT('W')
#define ARS_DDE_FOLDER                        TEXT('F')

#define ARS_DDE_SWITCH_NUMBER                 TEXT('N')
#define ARS_DDE_SWITCH_HANDLE                 TEXT('H')
#define ARS_DDE_SWITCH_CLIENT_NAME            TEXT('C')

#define ARS_DDE_LOGON_SERVER                  TEXT('S')
#define ARS_DDE_LOGON_USERID                  TEXT('U')
#define ARS_DDE_LOGON_PASSWORD                TEXT('P')
#define ARS_DDE_LOGON_RETURN_CODE             TEXT('R')

#define ARS_DDE_CHANGE_PASSWORD_CUR_PW        TEXT('C')
#define ARS_DDE_CHANGE_PASSWORD_NEW_PW1       TEXT('N')
#define ARS_DDE_CHANGE_PASSWORD_NEW_PW2       TEXT('V')

#define ARS_DDE_CRITERIA_BUTTON_1             TEXT('0')
#define ARS_DDE_CRITERIA_BUTTON_2             TEXT('1')
#define ARS_DDE_CRITERIA_BUTTON_3             TEXT('2')
#define ARS_DDE_CRITERIA_BUTTON_4             TEXT('3')
#define ARS_DDE_CRITERIA_BUTTON_5             TEXT('4')
#define ARS_DDE_DOCLIST_BUTTON_1              TEXT('5')
#define ARS_DDE_DOCLIST_BUTTON_2              TEXT('6')
#define ARS_DDE_DOCLIST_BUTTON_3              TEXT('7')
#define ARS_DDE_DOCLIST_BUTTON_4              TEXT('8')
#define ARS_DDE_DOCLIST_BUTTON_5              TEXT('9')
#define ARS_DDE_SUPPRESS_BUTTON_SEARCH        TEXT('S')
#define ARS_DDE_SUPPRESS_BUTTON_CLEAR         TEXT('C')
#define ARS_DDE_SUPPRESS_BUTTON_RESTORE       TEXT('R')
#define ARS_DDE_SUPPRESS_BUTTON_AND_OR        TEXT('D')
#define ARS_DDE_SUPPRESS_BUTTON_VIEW          TEXT('V')
#define ARS_DDE_SUPPRESS_BUTTON_PRINT         TEXT('P')
#define ARS_DDE_SUPPRESS_BUTTON_SORT          TEXT('T')
#define ARS_DDE_SUPPRESS_BUTTON_AUDIT         TEXT('A')
#define ARS_DDE_SUPPRESS_BUTTON_APPEND        TEXT('N')
#define ARS_DDE_SUPPRESS_BUTTON_AUTOSCROLL    TEXT('L')

#define ARS_DDE_FIELD_NAME                    TEXT('F')
#define ARS_DDE_FIELD_OPERATOR                TEXT('O')
#define ARS_DDE_FIELD_VALUE_1                 TEXT('1')
#define ARS_DDE_FIELD_VALUE_2                 TEXT('2')
#define ARS_DDE_FIELD_VALUE                   TEXT('V')
#define ARS_DDE_SEARCH_APPEND                 TEXT('A')
#define ARS_DDE_SEARCH_OR                     TEXT('O')

#define ARS_DDE_DOC_ID                        TEXT('D')
#define ARS_DDE_DOC_NUMBER                    TEXT('N')
#define ARS_DDE_DOC_PATH                      TEXT('P')
#define ARS_DDE_DOC_SELECTED                  TEXT('S')

#define ARS_DDE_RETRIEVE_RESGRP               TEXT('R')
#define ARS_DDE_RETRIEVE_COMBINED             TEXT('C')
#define ARS_DDE_RETRIEVE_APPEND               TEXT('A')

#define ARS_DDE_STORE_GROUP_NAME              TEXT('G')
#define ARS_DDE_STORE_APPL_NAME               TEXT('A')

#define ARS_DDE_ARRANGE_CASCADE               TEXT('C')
#define ARS_DDE_ARRANGE_TILE_HORZ             TEXT('H')
#define ARS_DDE_ARRANGE_TILE_VERT             TEXT('V')
#define ARS_DDE_ARRANGE_MAXIMIZE              TEXT('Z')
#define ARS_DDE_ARRANGE_RESTORE               TEXT('R')

#define ARS_DDE_PRINT_LOCAL                   TEXT('L')
#define ARS_DDE_PRINT_SERVER                  TEXT('S')
#define ARS_DDE_PRINT_COPIES                  TEXT('C')
#define ARS_DDE_PRINT_ROTATE                  TEXT('R')
#define ARS_DDE_PRINT_ROTATE_BEST             TEXT('B')
#define ARS_DDE_PRINT_ROTATE_ASIS             TEXT('A')
#define ARS_DDE_PRINT_ROTATE_PORTRAIT         TEXT('P')
#define ARS_DDE_PRINT_ROTATE_LANDSCAPE        TEXT('L')
#define ARS_DDE_PRINT_SHRINK                  TEXT('K')
#define ARS_DDE_PRINT_MILLIMETERS             TEXT('M')

#define ARS_DDE_ANNOTATE_PUBLIC               TEXT('U')
#define ARS_DDE_ANNOTATE_OK_TO_COPY           TEXT('C')
#define ARS_DDE_PAGE_NUMBER                   TEXT('G')

#define ARS_DDE_COPY_DOC_PAGES_ASIS           TEXT('A')
#define ARS_DDE_COPY_DOC_PAGES_CURRENT        TEXT('C')

#define ARS_DDE_USER_MSG_MODE                 TEXT('M')
#define ARS_DDE_USER_MSG_MODE_SHOW            TEXT('1')
#define ARS_DDE_USER_MSG_MODE_SHOW_IF_VISIBLE TEXT('2')
#define ARS_DDE_USER_MSG_MODE_SUPPRESS        TEXT('3')

/**********************************************************************/
/* DDE Command Parameter Keywords                                     */
/**********************************************************************/
#define ARS_DDE_OPR_EQUAL                     TEXT("EQ")
#define ARS_DDE_OPR_NOT_EQUAL                 TEXT("NE")
#define ARS_DDE_OPR_LESS_THAN                 TEXT("LT")
#define ARS_DDE_OPR_LESS_THAN_OR_EQUAL        TEXT("LE")
#define ARS_DDE_OPR_GREATER_THAN              TEXT("GT")
#define ARS_DDE_OPR_GREATER_THAN_OR_EQUAL     TEXT("GE")
#define ARS_DDE_OPR_BETWEEN                   TEXT("BW")
#define ARS_DDE_OPR_NOT_BETWEEN               TEXT("NB")
#define ARS_DDE_OPR_IN                        TEXT("IN")
#define ARS_DDE_OPR_NOT_IN                    TEXT("NI")
#define ARS_DDE_OPR_LIKE                      TEXT("LK")
#define ARS_DDE_OPR_NOT_LIKE                  TEXT("NL")

#define ARS_DDE_WINDOW_ZOOM                   TEXT("Z")
#define ARS_DDE_WINDOW_ICON                   TEXT("I")
#define ARS_DDE_WINDOW_NONE                   TEXT("N")

/**********************************************************************/
/* DDE Return Data List Item Separator                                */
/**********************************************************************/
#define ARS_DDE_DATA_SEPARATOR                TEXT("\t")

/**********************************************************************/
/* DDE Advise Loop Identifiers                                        */
/**********************************************************************/
#define ARS_DDE_ADVISE_LOOP_1                 TEXT("1")

/**********************************************************************/
/* DDE Advise Loop Events                                             */
/**********************************************************************/
#define ARS_DDE_EVENT_CRITERIA_BUTTON_1       TEXT("0")
#define ARS_DDE_EVENT_CRITERIA_BUTTON_2       TEXT("1")
#define ARS_DDE_EVENT_CRITERIA_BUTTON_3       TEXT("2")
#define ARS_DDE_EVENT_CRITERIA_BUTTON_4       TEXT("3")
#define ARS_DDE_EVENT_CRITERIA_BUTTON_5       TEXT("4")
#define ARS_DDE_EVENT_DOCLIST_BUTTON_1        TEXT("5")
#define ARS_DDE_EVENT_DOCLIST_BUTTON_2        TEXT("6")
#define ARS_DDE_EVENT_DOCLIST_BUTTON_3        TEXT("7")
#define ARS_DDE_EVENT_DOCLIST_BUTTON_4        TEXT("8")
#define ARS_DDE_EVENT_DOCLIST_BUTTON_5        TEXT("9")
#define ARS_DDE_EVENT_SWITCH_FOCUS            TEXT("S")
#define ARS_DDE_EVENT_SWITCH_FOCUS_2          TEXT("S2")
#define ARS_DDE_EVENT_SWITCH_FOCUS_3          TEXT("S3")
#define ARS_DDE_EVENT_SWITCH_FOCUS_4          TEXT("S4")
#define ARS_DDE_EVENT_SWITCH_FOCUS_5          TEXT("S5")

/**********************************************************************/
/* DDE Command Return Codes                                           */
/**********************************************************************/
#define ARS_DDE_RC_NO_ERROR                      0
#define ARS_DDE_RC_UNKNOWN_COMMAND               1
#define ARS_DDE_RC_PARM_NOT_SPECIFIED            2
#define ARS_DDE_RC_INVALID_PARM_VALUE            3
#define ARS_DDE_RC_SERVER_ERROR                  4
#define ARS_DDE_RC_FILE_ERROR                    5
#define ARS_DDE_RC_NOT_LOGGED_ON                 6
#define ARS_DDE_RC_MAX_FOLDERS_OPEN              7
#define ARS_DDE_RC_FOLDER_NOT_OPEN               8
#define ARS_DDE_RC_NO_DOC                        9
#define ARS_DDE_RC_USER_ACTION_IN_PROGRESS       11
#define ARS_DDE_RC_UNAUTHORIZED_OPERATION        12
#define ARS_DDE_RC_USER_CANCELLED_OPERATION      13
#define ARS_DDE_RC_NO_ACTIVE_DOC                 14
#define ARS_DDE_RC_INVALID_APPL_GROUP_NAME       15
#define ARS_DDE_RC_INVALID_APPL_NAME             16
#define ARS_DDE_RC_INVALID_INTEGER_FIELD         17
#define ARS_DDE_RC_INVALID_DECIMAL_FIELD         18
#define ARS_DDE_RC_INVALID_DATE_FIELD            19
#define ARS_DDE_RC_INVALID_APPLGRP_FIELD_TYPE    20
#define ARS_DDE_RC_DOC_NOT_VIEWABLE_OR_PRINTABLE 21
#define ARS_DDE_RC_INCORRECT_CURRENT_PASSWORD    22
#define ARS_DDE_RC_PASSWORD_TOO_SHORT            23
#define ARS_DDE_RC_NEW_PASSWORD_MISMATCH         24
#define ARS_DDE_RC_INVALID_USER_PASS_SERVER      25
#define ARS_DDE_RC_PASSWORD_EXPIRED              26
#define ARS_DDE_RC_TOO_MANY_VALUE_CHARS          27

/**********************************************************************/
/* DDE Help Context IDs                                               */
/**********************************************************************/
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_1     0x50800
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_2     0x50801
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_3     0x50802
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_4     0x50803
#define ARS_DDE_HELP_ID_CRITERIA_BUTTON_5     0x50804
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_1      0x50805
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_2      0x50806
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_3      0x50807
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_4      0x50808
#define ARS_DDE_HELP_ID_DOCLIST_BUTTON_5      0x50809
#define ARS_DDE_HELP_ID_SWITCH_FOCUS          0x5080A
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_2        0x5080B
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_3        0x5080C
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_4        0x5080D
#define ARS_DDE_HELP_ID_SWITCH_FOCUS_5        0x5080E

#endif
